clear
close all

frog = imread('/Users/marcel/Documents/MATLAB/0-images-exemples/frog.jpg');
frog_int = rgb2gray(frog);
min_int = min(min(frog_int));
max_int = max(max(frog_int));
'type de frog_int :'
whos frog_int
[n_int,x_int]=imhist(frog_int,256);

frog_pho = imnoise(frog_int, 'poisson');
min_pho = min(min(frog_pho));
max_pho = max(max(frog_pho));
'type de frog_pho :'
whos frog_pho
[n_pho,x_pho]=imhist(frog_pho,256);

frog_snp = imnoise(frog_pho, 'salt & pepper', 0.05);
min_snp = min(min(frog_snp));
max_snp = max(max(frog_snp));
'type de frog_snp :'
whos frog_snp
[n_snp,x_snp]=imhist(frog_snp,256);

frog_ree = double(frog_snp)/255.;
frog_ron = imnoise(frog_ree, 'gaussian', 0., .01);
min_ron = min(min(frog_ron));
max_ron = max(max(frog_ron));
'type de frog_ron :'
whos frog_ron
[n_ron,x_ron]=imhist(frog_ron,256);

figure

subplot(4,3,1), imshow(frog_int)
title({'frog\_int' ; ['min=',int2str(min_int),' max=',int2str(max_int)]})
subplot(4,3,2), imhist(frog_int,256)
subplot(4,3,3), plot(x_int, n_int-n_int), xlim([0 255])

subplot(4,3,4), imshow(frog_pho)
title({'frog\_pho' ; ['min=',int2str(min_pho),' max=',int2str(max_pho)]})
subplot(4,3,5), imhist(frog_pho,256)
subplot(4,3,6), plot(x_pho, n_pho-n_int), xlim([0 255])

subplot(4,3,7), imshow(frog_snp)
title({'frog\_snp' ; ['min=',int2str(min_snp),' max=',int2str(max_snp)]})
subplot(4,3,8), imhist(frog_snp,256)
subplot(4,3,9), plot(x_snp, n_snp-n_pho), xlim([0 255])

subplot(4,3,10), imshow(frog_ron)
title({'frog\_ron' ; ['min=',int2str(min_ron),' max=',int2str(max_ron)]})
subplot(4,3,11), imhist(frog_ron,256)
subplot(4,3,12), plot(x_ron, n_ron-n_snp), xlim([0 1])